<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr; 
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 49%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
            display: inline-block;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }

        #chats {
            width: 49%;
            height: 100%;
            left: 0%;
            background: rgb(19, 226, 216);
            overflow: auto;
            margin: 0;
            display: inline-block;
        }
        #chats p {
            border-bottom: 1px solid rgb(224, 8, 8);
            padding-bottom: .25rem;
        }
    </style>

</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
            <pre id="chats" ></pre>
        </main>
        <div id="controls">
            <label for="retrieve">Retrieve</label>
            <input type="retrieve" id="retrieve" name="retrieve" enterkeyhint="retrieve" value="message ID">
            <button type="button" id="retrieveBtn">Retrieve!</button>
            <button type="button" id="allBtn">Show all</button>
            <label for="recipient">To</label>
            <input type="text" id="recipient" value="username">
            <span></span><span></span>
            <label for="sender">From</label>
            <input type="text" id="sender" name="sender" value="username" disabled>
            <span></span><span></span>

            <label for="reply">Reply</label>
            <input type="text" id="reply" name="reply" value="message ID">
            <span></span><span></span>

            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
            <button type="button" id="sendBtn">Send</button>
            <a href="/logout"><button type="button" id="logoutBtn">Log out</button></a>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var retrieveField = document.getElementById('retrieve');
    var senderField = document.getElementById('sender');
    var recipientField = document.getElementById('recipient');
    var messageField = document.getElementById('message');
    var retrieveBtn = document.getElementById('retrieveBtn');
    var replyField = document.getElementById('reply'); 
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');
    var chats = document.getElementById('chats');
    var logoutBtn = document.getElementById('logoutBtn');

    var currentUsername = "{{ current_user.id }}";
    var csrf_token = "{{ csrf_token() }}";
    senderField.value = currentUsername;
    

    var checkChats = async () => {
        chats.innerHTML = '';
        res = await fetch('/chats');
        
        const head = document.createElement('h3');
        head.textContent = "  All your messages "+currentUsername+"!";
        chats.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text()
        chats.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
    };
    var retrieve = async (query) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `Searching for relevant messages with message-ID: ${query} `;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (sender, recipient, replyID, message) => {
        const id = reqId++;
        const q = `/send?sender=${encodeURIComponent(sender)}&recipient=${encodeURIComponent(recipient)}&replyID=${encodeURIComponent(replyID)}&message=${encodeURIComponent(message)}`;
        const token = new Headers({'X-CSRFToken': csrf_token});
        res = await fetch(q, { method: 'post', headers: token });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
        checkChats();
    };
    retrieveField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            retrieve(retrieveField.value);
        }
    });
    retrieveBtn.addEventListener('click', () => retrieve(retrieveField.value));
    allBtn.addEventListener('click', () => retrieve('*'));
    sendBtn.addEventListener('click', () => send(senderField.value, recipientField.value, replyField.value, messageField.value));
    logoutBtn.addEventListener('click', () => logout())
    checkChats();
</script>

</html>